searchNodes=[{"doc":"Generates a migration to add min and max aggregate functions to Postgres for the money_with_currency type.","ref":"Mix.Tasks.Money.Gen.Postgres.MinMaxFunctions.html","title":"Mix.Tasks.Money.Gen.Postgres.MinMaxFunctions","type":"task"},{"doc":"Generates a migration to add a composite type called :money_with_currency to a Postgres database. The :money_with_currency type created is a composite type and therefore may not be supported in other databases.","ref":"Mix.Tasks.Money.Gen.Postgres.MoneyWithCurrency.html","title":"Mix.Tasks.Money.Gen.Postgres.MoneyWithCurrency","type":"task"},{"doc":"Generates a migration to add a + operator to Postgres for the money_with_currency type","ref":"Mix.Tasks.Money.Gen.Postgres.PlusOperator.html","title":"Mix.Tasks.Money.Gen.Postgres.PlusOperator","type":"task"},{"doc":"Generates a migration to add a sum aggregate function to Postgres for the money_with_currency type.","ref":"Mix.Tasks.Money.Gen.Postgres.SumFunction.html","title":"Mix.Tasks.Money.Gen.Postgres.SumFunction","type":"task"},{"doc":"Functions to return SQL DDL commands that support the creation and deletion of the money_with_currency database type and associated aggregate functions.","ref":"Money.DDL.html","title":"Money.DDL","type":"module"},{"doc":"Returns the SQL string which when executed will define the money_with_currency data type. Arguments db_type : the type of the database for which the SQL string should be returned. Defaults to :postgres which is currently the only supported database type.","ref":"Money.DDL.html#create_money_with_currency/1","title":"Money.DDL.create_money_with_currency/1","type":"function"},{"doc":"Returns the SQL string which when executed will define min and max functions for the money_with_currency data type. Arguments db_type : the type of the database for which the SQL string should be returned. Defaults to :postgres which is currently the only supported database type.","ref":"Money.DDL.html#define_minmax_functions/1","title":"Money.DDL.define_minmax_functions/1","type":"function"},{"doc":"Returns the SQL string which when executed will define a + operator for the money_with_currency data type. Arguments db_type : the type of the database for which the SQL string should be returned. Defaults to :postgres which is currently the only supported database type.","ref":"Money.DDL.html#define_plus_operator/1","title":"Money.DDL.define_plus_operator/1","type":"function"},{"doc":"Returns the SQL string which when executed will define sum functions for the money_with_currency data type. Arguments db_type : the type of the database for which the SQL string should be returned. Defaults to :postgres which is currently the only supported database type.","ref":"Money.DDL.html#define_sum_function/1","title":"Money.DDL.define_sum_function/1","type":"function"},{"doc":"Returns the SQL string which when executed will drop the min and max functions for the money_with_currency data type. Arguments db_type : the type of the database for which the SQL string should be returned. Defaults to :postgres which is currently the only supported database type.","ref":"Money.DDL.html#drop_minmax_functions/1","title":"Money.DDL.drop_minmax_functions/1","type":"function"},{"doc":"Returns the SQL string which when executed will drop the money_with_currency data type. Arguments db_type : the type of the database for which the SQL string should be returned. Defaults to :postgres which is currently the only supported database type.","ref":"Money.DDL.html#drop_money_with_currency/1","title":"Money.DDL.drop_money_with_currency/1","type":"function"},{"doc":"Returns the SQL string which when executed will drop the + operator for the money_with_currency data type. Arguments db_type : the type of the database for which the SQL string should be returned. Defaults to :postgres which is currently the only supported database type.","ref":"Money.DDL.html#drop_plus_operator/1","title":"Money.DDL.drop_plus_operator/1","type":"function"},{"doc":"Returns the SQL string which when executed will drop the sum functions for the money_with_currency data type. Arguments db_type : the type of the database for which the SQL string should be returned. Defaults to :postgres which is currently the only supported database type.","ref":"Money.DDL.html#drop_sum_function/1","title":"Money.DDL.drop_sum_function/1","type":"function"},{"doc":"Returns a string that will Ecto execute a single SQL command. Arguments sql is a single SQL command Example iex&gt; Money.DDL . execute &quot;SELECT name FROM customers;&quot; &quot;execute &quot; SELECT name FROM customers ; &quot;&quot;","ref":"Money.DDL.html#execute/1","title":"Money.DDL.execute/1","type":"function"},{"doc":"Returns a string that will Ecto execute each SQL command. Arguments sql is a string of SQL commands that are separated by three newlines (&quot;\\n&quot;), that is to say two blank lines between commands in the file. Example iex&gt; Money.DDL . execute &quot; SELECT name FROM customers ; SELECT id FROM orders;&quot; &quot;execute &quot; &quot;&quot; SELECT name FROM customers; SELECT id FROM orders; &quot;&quot;&quot;&quot;","ref":"Money.DDL.html#execute_each/1","title":"Money.DDL.execute_each/1","type":"function"},{"doc":"Implements the Ecto.Type behaviour for a user-defined Postgres composite type called :money_with_currency . This is the preferred option for Postgres database since the serialized money amount is stored as a decimal number,","ref":"Money.Ecto.Composite.Type.html","title":"Money.Ecto.Composite.Type","type":"module"},{"doc":"","ref":"Money.Ecto.Composite.Type.html#cast/1","title":"Money.Ecto.Composite.Type.cast/1","type":"function"},{"doc":"","ref":"Money.Ecto.Composite.Type.html#cast_type/1","title":"Money.Ecto.Composite.Type.cast_type/1","type":"function"},{"doc":"","ref":"Money.Ecto.Composite.Type.html#embed_as/1","title":"Money.Ecto.Composite.Type.embed_as/1","type":"function"},{"doc":"","ref":"Money.Ecto.Composite.Type.html#equal?/2","title":"Money.Ecto.Composite.Type.equal?/2","type":"function"},{"doc":"Implements Ecto.Type behaviour for Money, where the underlying schema type is a map. This is the required option for databases such as MySQL that do not support composite types. In order to preserve precision, the amount is serialized as a string since the JSON representation of a numeric value is either an integer or a float. Decimal.to_string/1 is not guaranteed to produce a string that will round-trip convert back to the identical number.","ref":"Money.Ecto.Map.Type.html","title":"Money.Ecto.Map.Type","type":"module"},{"doc":"See Money.Ecto.Composite.Type.cast/1 .","ref":"Money.Ecto.Map.Type.html#cast/1","title":"Money.Ecto.Map.Type.cast/1","type":"function"},{"doc":"Callback implementation for Ecto.ParameterizedType.cast/2 .","ref":"Money.Ecto.Map.Type.html#cast/2","title":"Money.Ecto.Map.Type.cast/2","type":"function"},{"doc":"Callback implementation for Ecto.ParameterizedType.dump/3 .","ref":"Money.Ecto.Map.Type.html#dump/3","title":"Money.Ecto.Map.Type.dump/3","type":"function"},{"doc":"See Money.Ecto.Composite.Type.embed_as/1 .","ref":"Money.Ecto.Map.Type.html#embed_as/1","title":"Money.Ecto.Map.Type.embed_as/1","type":"function"},{"doc":"See Money.Ecto.Composite.Type.equal?/2 .","ref":"Money.Ecto.Map.Type.html#equal?/2","title":"Money.Ecto.Map.Type.equal?/2","type":"function"},{"doc":"Callback implementation for Ecto.ParameterizedType.init/1 .","ref":"Money.Ecto.Map.Type.html#init/1","title":"Money.Ecto.Map.Type.init/1","type":"function"},{"doc":"Callback implementation for Ecto.ParameterizedType.load/3 .","ref":"Money.Ecto.Map.Type.html#load/3","title":"Money.Ecto.Map.Type.load/3","type":"function"},{"doc":"Callback implementation for Ecto.ParameterizedType.type/1 .","ref":"Money.Ecto.Map.Type.html#type/1","title":"Money.Ecto.Map.Type.type/1","type":"function"},{"doc":"Provides several helpers to query DB for the Money type. Under the hood it delegates to Ecto.Query.API.fragment/1 , but might be helpful for compile-type sanity check for typos and better language server support. It is also designed to be an implementation-agnostic, meaning one can use these helpers without a necessity to explicitly specify a backing type. The default implementation recommends a Composite adapter, which is used by default. To use it with, say, MySQL , one should implement this behaviour for MySQL and declare the implementation as use Money.Ecto.Query.API, adapter: MyImpl.MySQL.Adapter Although the library provides the MySQL adapter too ( Money.Ecto.Query.API.Map.MySQL ,) but it is not actively maintained, so use it on your own. If for some reason you use Map type with Postgres , helpers are still available with use Money.Ecto.Query.API, adapter: Money.Ecto.Query.API.Map.Postgres","ref":"Money.Ecto.Query.API.html","title":"Money.Ecto.Query.API","type":"behaviour"},{"doc":"Native implementation of how to retrieve amount from the DB. For Postgres , it delegates to the function on the composite type, for other implementation it should return a Ecto.Query.API.fragment/1 .","ref":"Money.Ecto.Query.API.html#c:amount/1","title":"Money.Ecto.Query.API.amount/1","type":"macrocallback"},{"doc":"Ecto.Query.API helper, allowing to filter records having the same amount. Example: iex&gt; Organization ...&gt; |&gt; where ( [ o ] , amount_eq ( o . payroll , 100 ) ) ...&gt; |&gt; select ( [ o ] , o . payroll ) ...&gt; |&gt; Repo . all ( ) [ Money . new ( :EUR , &quot;100&quot; ) , Money . new ( :USD , &quot;100&quot; )","ref":"Money.Ecto.Query.API.html#amount_eq/2","title":"Money.Ecto.Query.API.amount_eq/2","type":"macro"},{"doc":"Ecto.Query.API helper, allowing to filter records having the amount greater than or equal to the one given as an argument. Example: iex&gt; Organization ...&gt; |&gt; where ( [ o ] , amount_ge ( o . payroll , 90 ) ) ...&gt; |&gt; select ( [ o ] , o . payroll ) ...&gt; |&gt; Repo . all ( ) [ Money . new ( :AUD , &quot;90&quot; ) , Money . new ( :USD , &quot;100&quot; ) ]","ref":"Money.Ecto.Query.API.html#amount_ge/2","title":"Money.Ecto.Query.API.amount_ge/2","type":"macro"},{"doc":"Ecto.Query.API helper, allowing to filter records having the amount in the range given as an argument. Accepts [min, max] , {min. max} , and min..max as a range. Example: iex&gt; Organization ...&gt; |&gt; where ( [ o ] , amount_in ( o . payroll , 90 .. 110 ) ) ...&gt; |&gt; select ( [ o ] , o . payroll ) ...&gt; |&gt; Repo . all ( ) [ Money . new ( :EUR , &quot;100&quot; ) , Money . new ( :USD , &quot;100&quot; ) ]","ref":"Money.Ecto.Query.API.html#amount_in/2","title":"Money.Ecto.Query.API.amount_in/2","type":"macro"},{"doc":"Ecto.Query.API helper, allowing to filter records having the amount less than or equal to the one given as an argument. Example: iex&gt; Organization ...&gt; |&gt; where ( [ o ] , amount_le ( o . payroll , 110 ) ) ...&gt; |&gt; select ( [ o ] , o . payroll ) ...&gt; |&gt; Repo . all ( ) [ Money . new ( :EUR , &quot;100&quot; ) , Money . new ( :USD , &quot;110&quot; ) ]","ref":"Money.Ecto.Query.API.html#amount_le/2","title":"Money.Ecto.Query.API.amount_le/2","type":"macro"},{"doc":"Cast decimal to the value accepted by the database.","ref":"Money.Ecto.Query.API.html#c:cast_decimal/1","title":"Money.Ecto.Query.API.cast_decimal/1","type":"callback"},{"doc":"Native implementation of how to retrieve currency_code from the DB. For Postgres , it delegates to the function on the composite type, for other implementation it should return a Ecto.Query.API.fragment/1 .","ref":"Money.Ecto.Query.API.html#c:currency_code/1","title":"Money.Ecto.Query.API.currency_code/1","type":"macrocallback"},{"doc":"Ecto.Query.API helper, allowing to filter records having the same currency. Example: iex&gt; Organization ...&gt; |&gt; where ( [ o ] , currency_eq ( o . payroll , :AUD ) ) ...&gt; |&gt; select ( [ o ] , o . payroll ) ...&gt; |&gt; Repo . all ( ) [ Money . new ( :AUD , &quot;50&quot; ) , Money . new ( :AUD , &quot;70&quot; )","ref":"Money.Ecto.Query.API.html#currency_eq/2","title":"Money.Ecto.Query.API.currency_eq/2","type":"macro"},{"doc":"Ecto.Query.API helper, allowing to filter records having one of currencies given as an argument. Example: iex&gt; Organization ...&gt; |&gt; where ( [ o ] , currency_in ( o . payroll , [ :USD , :EUR ] ) ) ...&gt; |&gt; select ( [ o ] , o . payroll ) ...&gt; |&gt; Repo . all ( ) [ Money . new ( :EUR , &quot;100&quot; ) , Money . new ( :USD , &quot;100&quot; ) ]","ref":"Money.Ecto.Query.API.html#currency_in/2","title":"Money.Ecto.Query.API.currency_in/2","type":"macro"},{"doc":"Ecto.Query.API helper, allowing to filter records having the same amount and currency. Example: iex&gt; Organization ...&gt; |&gt; where ( [ o ] , money_eq ( o . payroll , Money . new! ( 100 , :USD ) ) ) ...&gt; |&gt; select ( [ o ] , o . payroll ) ...&gt; |&gt; Repo . all ( ) [ Money . new ( :USD , &quot;100&quot; ) , Money . new ( :USD , &quot;100&quot; ) ]","ref":"Money.Ecto.Query.API.html#money_eq/2","title":"Money.Ecto.Query.API.money_eq/2","type":"macro"},{"doc":"Native implementation of how to sum several records having a field of the type Money in the DB. For Postgres , it delegates to the function on the composite type, for other implementation it should return a Ecto.Query.API.fragment/1 .","ref":"Money.Ecto.Query.API.html#c:sum/2","title":"Money.Ecto.Query.API.sum/2","type":"macrocallback"},{"doc":"Ecto.Query.API helper, allowing to aggregate by currency, suming amount. For more sophisticated aggregation, resort to raw fragment . Example: iex&gt; Organization ...&gt; |&gt; where ( [ o ] , o . name == ^ &quot;Lemon Inc.&quot; ) ...&gt; |&gt; total_by ( [ o ] , o . payroll ) ...&gt; |&gt; Repo . all ( ) [ Money . new ( :EUR , &quot;100&quot; ) , Money . new ( :USD , &quot;210&quot; ) ]","ref":"Money.Ecto.Query.API.html#total_by/3","title":"Money.Ecto.Query.API.total_by/3","type":"macro"},{"doc":"Ecto.Query.API helper, allowing to aggregate by currency, suming amount. Same as total_by/3 , but for the single currency only. Example: iex&gt; Organization ...&gt; |&gt; where ( [ o ] , o . name == ^ &quot;Lemon Inc.&quot; ) ...&gt; |&gt; total_by ( [ o ] , o . payroll , :USD ) ...&gt; |&gt; Repo . one ( ) [ Money . new ( :USD , &quot;210&quot; ) ]","ref":"Money.Ecto.Query.API.html#total_by/4","title":"Money.Ecto.Query.API.total_by/4","type":"macro"},{"doc":"Implements Ecto validations for the Money.t/0 type based upon the Money.Ecto.Composite.Type type.","ref":"Money.Validate.html","title":"Money.Validate","type":"module"},{"doc":"Validates the properties of a Money.t/0 . This function, including its options, is designed to mirror the function Ecto.Changeset.validate_number/3 . Options :less_than :greater_than :less_than_or_equal_to :greater_than_or_equal_to :equal_to :not_equal_to :message - the message on failure, defaults to one of: &quot;must be less than %{money}&quot; &quot;must be greater than %{money}&quot; &quot;must be less than or equal to %{money}&quot; &quot;must be greater than or equal to %{money}&quot; &quot;must be equal to %{money}&quot; &quot;must be not equal to %{money}&quot; Examples validate_money(changeset, :value, less_than: Money.new(:USD, 200)) validate_money(changeset, :value, less_than_or_equal_to: Money.new(:USD, 200) validate_money(changeset, :value, less_than_or_equal_to: Money.new(:USD, 100)) validate_money(changeset, :value, greater_than: Money.new(:USD, 50)) validate_money(changeset, :value, greater_than_or_equal_to: Money.new(:USD, 50)) validate_money(changeset, :value, greater_than_or_equal_to: Money.new(:USD, 100))","ref":"Money.Validate.html#validate_money/3","title":"Money.Validate.validate_money/3","type":"function"},{"doc":"Money_SQL implements a set of functions to store and retrieve data structured as a %Money{} type that is composed of an ISO 4217 currency code and a currency amount. See ex_money for details of using Money . Note that ex_money_sql depends on ex_money .","ref":"readme.html","title":"Introduction to Money SQL","type":"extras"},{"doc":"As of ex_money_sql version 1.4.0 the composite type for postgres, Money.Ecto.Composite.Type is defined as a parameterized type . This is compatible with earlier versions with the exception of the behaviour of the type/2 macro used to cast results. These calls have to be changed as follows: # ex_money_sql version 1.3 and earlier where ( Credit , [ c ] , c . price &lt; type ( ^ value , Money.Ecto.Composite.Type ) ) # ex_money_sql version 1.4 and later where ( Credit , [ c ] , c . price &lt; type ( ^ value , ^ Money.Ecto.Composite.Type . cast_type ( ) ) ) # When the query is a schema query this is preferred where ( Credit , [ c ] , c . price &lt; type ( ^ value , c . price ) )","ref":"readme.html#migrating-from-money-sql-versions-1-3-or-earlier","title":"Introduction to Money SQL - Migrating from Money SQL versions 1.3 or earlier","type":"extras"},{"doc":"Money_SQL is supported on Elixir 1.6 and later only","ref":"readme.html#prerequisities","title":"Introduction to Money SQL - Prerequisities","type":"extras"},{"doc":"Money_SQL provides custom Ecto data types and a custom Postgres data type to provide serialization of Money.t types without losing precision whilst also maintaining the integrity of the {currency_code, amount} relationship. To serialise and retrieve money types from a database the following steps should be followed: First generate the migration to create the custom type: mix money . gen . postgres . money_with_currency * creating priv / repo / migrations * creating priv / repo / migrations / 20161007234652 _add_money_with_currency_type_to_postgres . exs Then migrate the database: mix ecto . migrate 07 : 09 : 28.637 [ info ] == Running MoneyTest.Repo.Migrations.AddMoneyWithCurrencyTypeToPostgres . up / 0 forward 07 : 09 : 28.640 [ info ] execute &quot;CREATE TYPE public.money_with_currency AS (currency_code char(3), amount numeric)&quot; 07 : 09 : 28.647 [ info ] == Migrated in 0.0 s Create your database migration with the new type (don't forget to mix ecto.migrate as well): defmodule MoneyTest.Repo.Migrations.CreateLedger do use Ecto.Migration def change do create table ( :ledgers ) do add :amount , :money_with_currency timestamps ( ) end end end Create your schema using the Money.Ecto.Composite.Type ecto type: defmodule Ledger do use Ecto.Schema schema &quot;ledgers&quot; do field :amount , Money.Ecto.Composite.Type timestamps ( ) end end Insert into the database: iex&gt; Repo . insert % Ledger { amount : Money . new ( :USD , &quot;100.00&quot; ) } [ debug ] QUERY OK db = 4.5 ms INSERT INTO &quot;ledgers&quot; ( &quot;amount&quot; , &quot;inserted_at&quot; , &quot;updated_at&quot; ) VALUES ( $ 1 , $ 2 , $ 3 ) [ { &quot;USD&quot; , # Decimal &lt; 100.00 &gt; } , { { 2016 , 10 , 7 } , { 23 , 12 , 13 , 0 } } , { { 2016 , 10 , 7 } , { 23 , 12 , 13 , 0 } } ] Retrieve from the database: iex&gt; Repo . all Ledger [ debug ] QUERY OK source = &quot;ledgers&quot; db = 5.3 ms decode = 0.1 ms queue = 0.1 ms SELECT l0 . &quot;amount&quot; , l0 . &quot;inserted_at&quot; , l0 . &quot;updated_at&quot; FROM &quot;ledgers&quot; AS l0 [ ] [ % Ledger { __meta__ : # Ecto.Schema.Metadata &lt; :loaded , &quot;ledgers&quot; &gt; , amount : #&lt;:USD, 100.00&gt;, inserted_at : ~N[2017-02-21 00:15:40.979576] , updated_at : ~N[2017-02-21 00:15:40.991391] } ]","ref":"readme.html#serializing-to-a-postgres-database-with-ecto","title":"Introduction to Money SQL - Serializing to a Postgres database with Ecto","type":"extras"},{"doc":"Since MySQL does not support composite types, the :map type is used which in MySQL is implemented as a JSON column. The currency code and amount are serialised into this column. defmodule MoneyTest.Repo.Migrations.CreateLedger do use Ecto.Migration def change do create table ( :ledgers ) do add :amount , :map timestamps ( ) end end end Create your schema using the Money.Ecto.Map.Type ecto type: defmodule Ledger do use Ecto.Schema schema &quot;ledgers&quot; do field :amount , Money.Ecto.Map.Type timestamps ( ) end end Insert into the database: iex&gt; Repo . insert % Ledger { amount_map : Money . new ( :USD , 100 ) } [ debug ] QUERY OK db = 25.8 ms INSERT INTO &quot;ledgers&quot; ( &quot;amount_map&quot; , &quot;inserted_at&quot; , &quot;updated_at&quot; ) VALUES ( $ 1 , $ 2 , $ 3 ) RETURNING &quot;id&quot; [ %{ amount : &quot;100&quot; , currency : &quot;USD&quot; } , { { 2017 , 2 , 21 } , { 0 , 15 , 40 , 979576 } } , { { 2017 , 2 , 21 } , { 0 , 15 , 40 , 991391 } } ] { :ok , % MoneyTest.Thing { __meta__ : # Ecto.Schema.Metadata &lt; :loaded , &quot;ledgers&quot; &gt; , amount : nil , amount_map : # Money &lt; :USD , 100 &gt; , id : 3 , inserted_at : ~N[2017-02-21 00:15:40.979576] , updated_at : ~N[2017-02-21 00:15:40.991391] } } Retrieve from the database: iex&gt; Repo . all Ledger [ debug ] QUERY OK source = &quot;ledgers&quot; db = 16.1 ms decode = 0.1 ms SELECT t0 . &quot;id&quot; , t0 . &quot;amount_map&quot; , t0 . &quot;inserted_at&quot; , t0 . &quot;updated_at&quot; FROM &quot;ledgers&quot; AS t0 [ ] [ % Ledger { __meta__ : # Ecto.Schema.Metadata &lt; :loaded , &quot;ledgers&quot; &gt; , amount_map : # Money &lt; :USD , 100 &gt; , id : 3 , inserted_at : ~N[2017-02-21 00:15:40.979576] , updated_at : ~N[2017-02-21 00:15:40.991391] } ] Notes: In order to preserve precision of the decimal amount, the amount part of the %Money{} struct is serialised as a string. This is done because JSON serializes numeric values as either integer or float , neither of which would preserve precision of a decimal value. The precision of the serialized string value of amount is affected by the setting of Decimal.get_context . The default is 28 digits which should cater for your requirements. Serializing the amount as a string means that SQL query arithmetic and equality operators will not work as expected. You may find that CAST ing the string value will restore some of that functionality. For example: CAST(JSON_EXTRACT(amount_map, '$.amount') AS DECIMAL(20, 8)) AS amount;","ref":"readme.html#serializing-to-a-mysql-or-other-non-postgres-database-with-ecto","title":"Introduction to Money SQL - Serializing to a MySQL (or other non-Postgres) database with Ecto","type":"extras"},{"doc":"Then the schema type is Money.Ecto.Composite.Type then any option that is applicable to Money.parse/2 or Money.new/3 can be added to the field definition. These options will then be applied when Money.Ecto.Composite.Type.cast/2 or Money.Ecto.Composite.Type.load/3 is called. These functions are called with loading data from the database or when calling Ecto.Changeset.cast/3 is called. Typically this is useful to: Apply a default currency to a field input representing a money amount. Add formatting options to the returned t:Money that will be applied when calling Money.to_string/2 Consider the following example where a money amount will be considered in a default currency if no currency is applied: Example schema The example below has three columns defined as Money.Ecto.Composite.Type . :payroll will be cast as with the default currency :JPY if no currency field is provided. Note that if no :default_currency option is defined, the default currency will be derived from the current locale or configured :locale option. :tax is defined with the option :fractional_digits . This option will be applied when formatting :tax with Money.to_string/2 :default is the t:Money that is used if the :value field is nil both when casting and when loading from the database. defmodule Organization do use Ecto.Schema import Ecto.Changeset @primary_key false schema &quot;organizations&quot; do field :payroll , Money.Ecto.Composite.Type , default_currency : :JPY field :tax , Money.Ecto.Composite.Type , fractional_digits : 4 field :value , Money.Ecto.Composite.Type , default : Money . new ( :USD , 0 ) field :name , :string field :employee_count , :integer timestamps ( ) end def changeset ( organization , params \\\\ %{ } ) do organization |&gt; cast ( params , [ :payroll ] ) end end Changeset execution In the following example, a default of :JPY currency (using our previous schema example) will be applied when casting the changeset. iex&gt; changeset = Organization . changeset ( % Organization { } , %{ payroll : &quot;0&quot; } ) iex&gt; changeset . changes . payroll == Money . new ( :JPY , 0 ) true","ref":"readme.html#casting-money-with-changesets","title":"Introduction to Money SQL - Casting Money with Changesets","type":"extras"},{"doc":"Since the datatype used to store Money in Postgres is a composite type (called :money_with_currency ), the standard aggregation functions like sum and average are not supported and the order_by clause doesn't perform as expected. Money provides mechanisms to provide these functions. Plus operator + Money defines a migration generator which, when migrated to the database with mix ecto.migrate , supports the + operator for :money_with_currency columns. The steps are: Generate the migration by executing mix money.gen.postgres.plus_operator Migrate the database by executing mix ecto.migrate Formulate an Ecto query to use the + operator iex&gt; q = Ecto.Query . select Item , [ l ] , type ( fragment ( &quot;price + price&quot; ) , l . price ) # Ecto.Query &lt; from l0 in Item , select : type ( fragment ( &quot;price + price&quot; ) , l0 . price ) &gt; iex&gt; Repo . one q [ debug ] QUERY OK source = &quot;items&quot; db = 5.6 ms queue = 0.5 ms SELECT price + price :: money_with_currency FROM &quot;items&quot; AS l0 [ ] # Money &lt; :USD , 200 &gt; ] Aggregate functions: sum() Money provides a migration generator which, when migrated to the database with mix ecto.migrate , supports performing sum() aggregation on Money types. The steps are: Generate the migration by executing mix money.gen.postgres.sum_function Migrate the database by executing mix ecto.migrate Formulate an Ecto query to use the aggregate function sum() # Formulate the query. Note the required use of the type() # expression which is needed to inform Ecto of the return # type of the function iex&gt; q = Ecto.Query . select Item , [ l ] , type ( sum ( l . price ) , l . price ) # Ecto.Query &lt; from l0 in Item , select : type ( sum ( l . price ) , l . price ) &gt; iex&gt; Repo . all q [ debug ] QUERY OK source = &quot;items&quot; db = 6.1 ms SELECT sum ( l0 . &quot;price&quot; ) :: money_with_currency FROM &quot;items&quot; AS l0 [ ] [ # Money &lt; :USD , 600 &gt; ] The function Repo.aggregate/3 can also be used. However at least ecto version 3.2.4 is required for this to work correctly for custom ecto types such as :money_with_currency . iex&gt; Repo . aggregate ( Item , :sum , :price ) # Money &lt; :USD , 600 &gt; Note that to preserve the integrity of Money it is not permissable to aggregate money that has different currencies. If you attempt to aggregate money with different currencies the query will abort and an exception will be raised: iex&gt; Repo . all q [ debug ] QUERY ERROR source = &quot;items&quot; db = 4.5 ms SELECT sum ( l0 . &quot;price&quot; ) :: money_with_currency FROM &quot;items&quot; AS l0 [ ] ** (Postgrex.Error) ERROR 22033 (): Incompatible currency codes. Expected all currency codes to be USD Aggregate functions: min() and max() Money provides a migration generator which, when migrated to the database with mix ecto.migrate , supports performing min() and max() aggregation on Money types. The steps are: Generate the migration by executing mix money.gen.postgres.min_max_functions Migrate the database by executing mix ecto.migrate Formulate an Ecto query to use the aggregate function min() or max() # Formulate the query. Note the required use of the type() # expression which is needed to inform Ecto of the return # type of the function iex&gt; q = Ecto.Query . select Item , [ l ] , type ( min ( l . price ) , l . price ) # Ecto.Query &lt; from l0 in Item , select : type ( min ( l . price ) , l . price ) &gt; iex&gt; Repo . all q [ debug ] QUERY OK source = &quot;items&quot; db = 6.1 ms SELECT min ( l0 . &quot;price&quot; ) :: money_with_currency FROM &quot;items&quot; AS l0 [ ] [ # Money &lt; :USD , 600 &gt; ] The function Repo.aggregate/3 can also be used. However at least ecto version 3.2.4 is required for this to work correctly for custom ecto types such as :money_with_currency . iex&gt; Repo . aggregate ( Item , :min , :price ) # Money &lt; :USD , 600 &gt; Note that to preserve the integrity of Money it is not permissable to aggregate money that has different currencies. If you attempt to aggregate money with different currencies the query will abort and an exception will be raised: iex&gt; Repo . all q [ debug ] QUERY ERROR source = &quot;items&quot; db = 4.5 ms SELECT min ( l0 . &quot;price&quot; ) :: money_with_currency FROM &quot;items&quot; AS l0 [ ] ** (Postgrex.Error) ERROR 22033 (): Incompatible currency codes. Expected all currency codes to be USD Order_by with Money Since :money_with_currency is a composite type, the default order_by results may surprise since the ordering is based upon the type structure, not the money amount. Postgres defines a means to access the components of a composite type and therefore sorting can be done in a more predictable fashion. For example: # In this example we are decomposing the the composite column called # `price` and using the sub-field `amount` to perform the ordering. iex&gt; q = from l in Item , select : l . price , order_by : fragment ( &quot;amount(price)&quot; ) # Ecto.Query &lt; from l in Item , order_by : [ asc : fragment ( &quot;amount(price)&quot; ) ] , select : l . amount &gt; iex&gt; Repo . all q [ debug ] QUERY OK source = &quot;items&quot; db = 2.0 ms SELECT l0 . &quot;price&quot; FROM &quot;items&quot; AS l0 ORDER BY amount ( price ) [ ] [ # Money &lt; :USD , 100.00000000 &gt; , # Money &lt; :USD , 200.00000000 &gt; , # Money &lt; :USD , 300.00000000 &gt; , # Money &lt; :AUD , 300.00000000 &gt; ] Note that the results may still be unexpected. The example above shows the correct ascending ordering by amount(price) however the ordering is not currency code aware and therefore mixed currencies will return a largely meaningless order.","ref":"readme.html#postgres-database-functions","title":"Introduction to Money SQL - Postgres Database functions","type":"extras"},{"doc":"Money can be installed by adding ex_money_sql to your list of dependencies in mix.exs and then executing mix deps.get def deps do [ { :ex_money_sql , &quot;~&gt; 1.0&quot; } , ... ] end","ref":"readme.html#installation","title":"Introduction to Money SQL - Installation","type":"extras"},{"doc":"When upgrading from ex_money_sql version 1.3.x to 1.4.x and later, please read the important migration information in the README Note That money_sql is supported on Elixir 1.11 and later only from ex_money_sql version 1.7.0.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.9.0 released on April 28th, 2022.","ref":"changelog.html#money_sql-v1-9-0","title":"Changelog - Money_SQL v1.9.0","type":"extras"},{"doc":"Adds Money.Ecto.Query.API query helpers to simplify Ecto queries involving money columns. Thanks very much to @am-kantox for the excellent suggestion and PR.","ref":"changelog.html#enhancements","title":"Changelog - Enhancements","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.8.0 released on December 26th, 2022.","ref":"changelog.html#money_sql-v1-8-0","title":"Changelog - Money_SQL v1.8.0","type":"extras"},{"doc":"Adds migrations and SQL functions to support min and max aggregate functions for Postgres when using the money_with_currency composite data type. The new mix task is money.gen.postgres.min_max_functions . Renames the migration task money.gen.postgres.aggregate_functions to money.gen.postgres.sum_function to better reflect its intent. This change affects only new installations. It has no effect on pre-existing generated migrations.","ref":"changelog.html#enhancements","title":"Changelog - Enhancements","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.7.3 released on December 18th, 2022.","ref":"changelog.html#money_sql-v1-7-3","title":"Changelog - Money_SQL v1.7.3","type":"extras"},{"doc":"WHen loading money from the database with the Money.Ecto.Map.Type type, do not do localized parsing of the amount. The amount is always saved using Decimal.to_string/1 and therefore is not localized. It must not be parsed with localization on loading.","ref":"changelog.html#bug-fixes","title":"Changelog - Bug Fixes","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.7.2 released on August 27th, 2022.","ref":"changelog.html#money_sql-v1-7-2","title":"Changelog - Money_SQL v1.7.2","type":"extras"},{"doc":"Makes the aggregate functions parallel-safe which provides up to 100% speed improvement. Thanks to @milangupta1 for the PR.","ref":"changelog.html#bug-fixes","title":"Changelog - Bug Fixes","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.7.1 released on July 8th, 2022.","ref":"changelog.html#money_sql-v1-7-1","title":"Changelog - Money_SQL v1.7.1","type":"extras"},{"doc":"Fixes casting a money map when the currency is nil . Thanks to @frahugo for the report. Closes #24.","ref":"changelog.html#bug-fixes","title":"Changelog - Bug Fixes","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.7.0 released on May 21st, 2022.","ref":"changelog.html#money_sql-v1-7-0","title":"Changelog - Money_SQL v1.7.0","type":"extras"},{"doc":"Adds the module Money.Validation to provide Ecto Changeset validations . In particular it adds Money.Validation.validate_money/3 which behaves exactly like Ecto.Changeset.validate_number/3 only for Money.t/0 types.","ref":"changelog.html#enhancements","title":"Changelog - Enhancements","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.6.0 released on December 31st, 2021. Note That money_sql is now supported on Elixir 1.10 and later only.","ref":"changelog.html#money_sql-v1-6-0","title":"Changelog - Money_SQL v1.6.0","type":"extras"},{"doc":"t:Money.Ecto.Composite.Type and t:Money.Ecto.Map.Type now return the exception module when there is an error in cast/1 . For example: iex&gt; Money.Ecto.Composite.Type . cast ( &quot;&quot; ) == { :error , [ exception : Money.InvalidAmountError , message : &quot;Amount cannot be converted to a number: \\&quot; \\&quot; &quot; ] } The expected exceptions are: Money.InvalidAmountError Money.UnknownCurrencyError Money.ParseError Thanks to @DaTrader for the enhancement request.","ref":"changelog.html#enhancements","title":"Changelog - Enhancements","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.5.2 released on December 13th, 2021. Note That money_sql is now supported on Elixir 1.10 and later only.","ref":"changelog.html#money_sql-v1-5-2","title":"Changelog - Money_SQL v1.5.2","type":"extras"},{"doc":"Fixes Ecto.ParameterizedType.embed_as/2 callback for the Ecto.ParameterizedType behaviour. Thanks to @nseantanly for the report and the PR.","ref":"changelog.html#bug-fixes","title":"Changelog - Bug Fixes","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.5.1 released on December 8th, 2021. Note That money_sql is now supported on Elixir 1.10 and later only.","ref":"changelog.html#money_sql-v1-5-1","title":"Changelog - Money_SQL v1.5.1","type":"extras"},{"doc":"Implements Ecto.ParameterizedType.equal?/3 callback for the Ecto.ParameterizedType behaviour. Thanks to @namhoangyojee for the report and the PR. Adds @impl Ecto.ParamaterizedType to the relevant callbacks.","ref":"changelog.html#bug-fixes","title":"Changelog - Bug Fixes","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.5.0 released on September 25th, 2021. Enhancements Adds a + operator for the Postgres type :money_with_currency The name of the migration to create the :money_with_currency type has shortened to be money.gen.postgres.money_with_currency","ref":"changelog.html#money_sql-v1-5-0","title":"Changelog - Money_SQL v1.5.0","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.4.5 released on June 3rd, 2021. Bug Fixes Remove conditional compilation in Money.Ecto.Composite.Type - the type is always Ecto.ParameterizedType .","ref":"changelog.html#money_sql-v1-4-5","title":"Changelog - Money_SQL v1.4.5","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.4.4 released on March 18th, 2021. Bug Fixes Don't use is_struct/1 guard to support compatibility on older Elixir releases","ref":"changelog.html#money_sql-v1-4-4","title":"Changelog - Money_SQL v1.4.4","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.4.3 released on February 17th, 2021. Bug Fixes Don't propogate a :default option into the t:Money from the schema. Fixes #14. Thanks to @emaiax.","ref":"changelog.html#money_sql-v1-4-3","title":"Changelog - Money_SQL v1.4.3","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.4.2 released on February 12th, 2021. Bug Fixes Dumping/loading nil returns {:ok, nil} . Thanks to @morinap.","ref":"changelog.html#money_sql-v1-4-2","title":"Changelog - Money_SQL v1.4.2","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.4.1 released on February 11th, 2021. Bug Fixes Casting nil returns {:ok, nil} . Thanks to @morinap.","ref":"changelog.html#money_sql-v1-4-1","title":"Changelog - Money_SQL v1.4.1","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.4.0 released on February 10th, 2021. Bug Fixes Fix parsing error handling in Money.Ecto.Composite.Type.cast/2 . Thanks to @NikitaAvvakumov. Closes #10. Fix casting localized amounts. Thanks to @olivermt. Closes #11. Enhancements Changes Money.Ecto.Composite.Type and Money.Ecto.Map.Type to be ParameterizedType . As a result, Ecto 3.5 or later is required. This change allows configuration of format options for the :money_with_currency to added as parameters in the Ecto schema. For the example schema: defmodule Organization do use Ecto.Schema @primary_key false schema &quot;organizations&quot; do field :payroll , Money.Ecto.Composite.Type field :tax , Money.Ecto.Composite.Type , fractional_digits : 4 field :name , :string field :employee_count , :integer timestamps ( ) end end The field :tax will be instantiated as a Money.t with :format_options of fractional_digits: 4 .","ref":"changelog.html#money_sql-v1-4-0","title":"Changelog - Money_SQL v1.4.0","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.3.1 released on September 30th, 2020. Bug Fixes Fixes compatibility with both Decimal version 1.x and 2.x . Thanks to @doughsay and @coladarci for the report. Closes #8.","ref":"changelog.html#money_sql-v1-3-1","title":"Changelog - Money_SQL v1.3.1","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.3.0 released on January 30th, 2020. Enhancements Updates to ex_money version 5.0 . Thanks to @morgz","ref":"changelog.html#money_sql-v1-3-0","title":"Changelog - Money_SQL v1.3.0","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.2.1 released on November 3rd, 2019. Bug Fixes Fixes Money.Ecto.Composite.Type and Money.Ecto.Map.Type by ensuring the load/1 and cast/1 callbacks conform to their typespecs. Thanks to @bgracie. Closes #4 and #5. Fixes the migration templates for money.gen.postgres.aggregate_functions to use numeric intermediate types rather than numeric(20,8) . For current installations it should be enough to run mix money.gen.postgres.aggregate_functions again followed by mix ecto.migrate to install the corrected aggregate function.","ref":"changelog.html#money_sql-v1-2-1","title":"Changelog - Money_SQL v1.2.1","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.2.0 released on November 2nd, 2019. Bug Fixes Removes the precision specification from intermediate results of the sum aggregate function for Postgres. Enhancements Adds equal?/2 callbacks to the Money.Ecto.Composite.Type and Money.Ecto.Map.Type for ecto_sql version 3.2","ref":"changelog.html#money_sql-v1-2-0","title":"Changelog - Money_SQL v1.2.0","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.1.0 released on August 22nd, 2019. Enhancements Renames the migration that generator that creates the Postgres composite type to be more meaningful. Bug Fixes Correctly generate and execute migrations. Fixes #1 and #2. Thanks to @davidsulc, @KungPaoChicken.","ref":"changelog.html#money_sql-v1-1-0","title":"Changelog - Money_SQL v1.1.0","type":"extras"},{"doc":"This is the changelog for Money_SQL v1.0.0 released on July 8th, 2019. Enhancements Initial release. Extracted from ex_money","ref":"changelog.html#money_sql-v1-0-0","title":"Changelog - Money_SQL v1.0.0","type":"extras"},{"doc":"","ref":"license.html","title":"LICENSE","type":"extras"},{"doc":"Copyright 2017-2019 Kip Cole Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http :// www . apache . org / licenses / LICENSE - 2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html#license","title":"LICENSE - License","type":"extras"}]